@isTest
public class HOG_SAPConfirmationsServiceMockImpl implements WebServiceMock {

    private Boolean mockError = false;

    public HOG_SAPConfirmationsServiceMockImpl() {
        this.mockError = true;
    }

    public HOG_SAPConfirmationsServiceMockImpl(Boolean mockError) {
        this.mockError = mockError;
    }

   public void doInvoke(
           Object stub,
           Object request,
           Map<String, Object> response,
           String endpoint,
           String soapAction,
           String requestName,
           String responseNS,
           String responseName,
           String responseType) {

        // Create response element from the autogenerated class.
        // Populate response element.
        // Add response element to the response parameter, as follows:
        //response.put('response_x', responseElement);
        HOG_SAPConfirmationsService.DT_SFDC_Confirmation_Resp resp = new HOG_SAPConfirmationsService.DT_SFDC_Confirmation_Resp();
        resp.Confirmation_Resp = new List<HOG_SAPConfirmationsService.Confirmation_Resp_element>();

        //Create response for all confirmations in request
        HOG_SAPConfirmationsService.DT_SFDC_Confirmation[] confirmationRequestList = ((HOG_SAPConfirmationsService.DT_SFDC_Confirmations) request).Confirmation;
        for(Integer i=0; i < confirmationRequestList.size(); i++) {
          HOG_SAPConfirmationsService.DT_SFDC_Confirmation confirmation = confirmationRequestList[i];
          HOG_SAPConfirmationsService.Confirmation_Resp_element respElement = new HOG_SAPConfirmationsService.Confirmation_Resp_element();
          respElement.Conf_No = confirmation.Order_Number + '-' + confirmation.Operation_Number + (i+1);
          respElement.OBJNR = null;
          respElement.Status = (this.mockError) ? 'E -' + ' ' + confirmation.Order_Number + ' not found.' :
                  'Confirmation successfully created!';
          resp.Confirmation_Resp.add(respElement);
        }

        response.put('response_x', resp);
   }
}